GTPin: Data Structures

GTPin

- Main Page
- Related Pages
- Modules
- Data Structures

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Data Structures
Here are the data structures with brief descriptions:

gtpin::Array< T, N > | A container that encapsulates fixed size arrays
gtpin::Array< T, 0 > | Specialization of Array template for zero-size array
gtpin::EnableIf_< B, T > |
gtpin::final | < List of IGtIns instruction pointers
gtpin::GtAccessType | Type of access to memory region, register, etc
gtpin::GtAddrMode | Addressing mode of the instruction operand
gtpin::GtAddrSpace | Logically distinct address spaces in GFX runtime (OpenCL, Level-Zero, etc.)
gtpin::GtArchRegType | Type of the architecture (ARF) register
gtpin::GtAtomicOp | Type of the atomic operation
gtpin::GtBinaryFormat | Format of a binary GFX program module
gtpin::GtChannelOffset | Offset of the execution (channel) mask
gtpin::GtCondModifier | An attribute that specifies whether and how the instruction modifies flag register
gtpin::GtCoreMemDeleter | Raw memory deleter in the GTPin core storage
gtpin::GtCoreObjDeleter< T > | Deleter for a single (non-array) object allocated in the GTPin core storage
gtpin::GtCoreString | C string allocated in the GTPin core storage and managed by UniquePtr
gtpin::GtDataType | Data type of the instruction operand
gtpin::GtDstRegion | Destination operand of the GEN instruction
gtpin::GtDx11ExecDesc | Execution descriptor of the DX11 shader (GPU_PLATFORM_DX11)
gtpin::GtDx12ExecDesc | Execution descriptor of the DX12 shader (GPU_PLATFORM_DX12)
gtpin::GtDx12RtExecDesc | Execution descriptor of the DX12 RayTracing shader (GPU_PLATFORM_DX12)
gtpin::GtEventReaction | Wrapper class of the EVENT_REACTION enumeration that defines return value of the event handling callback
gtpin::GtExecMask | Execution mask of the instruction
gtpin::GtExecSize | Execution size of the instruction
gtpin::GtGenModelId | The GEN model identifier
gtpin::GtGpuPlatform | GPU platform
gtpin::GtHliCallStd | Calling convention of the HLI function
gtpin::GtHliCompilationOptions | HLI module compilation options
gtpin::GtHliFunction< RET, PRMS > | Class that represents an HLI function and provides convenient interface for generating HLI function calls
gtpin::GtHliLanguage | Source language of the High-Level Instrumentation (HLI) module
gtpin::GtHliParamTraits | Traits of HLI function parameter
gtpin::GtHliParamType | Type of an HLI function parameter
gtpin::GtIargImmValue | Class that represents an immediate scalar value of the HLI argument and provides conversion methods to/from other trivially copyable types
gtpin::GtIargType | Type of an HLI function argument
gtpin::GtImm | Immediate operand of the GEN instruction
gtpin::GtIpoint | Relative location within the code at which instrumentation is inserted
gtpin::GtKernelArgument | Descriptor of the kernel's payload argument
gtpin::GtKernelDispatchL0Runtime | Level-Zero runtime information associated with the kernel instance dispatched for execution
gtpin::GtKernelDispatchOclRuntime | Span of immutable memory buffers
gtpin::GtKernelExecDesc | Kernel execution descriptor
gtpin::GtKernelExecStage | Enumeration of the kernel execution stages (contexts)
gtpin::GtKernelType | Type of a kernel (shader)
gtpin::GtL0ExecDesc | Execution descriptor of the L0 kernel (GPU_PLATFORM_L0)
gtpin::GtMapped< MM, VARS > | Template container of host-to-device mapped variables
gtpin::GtMathFC | Math Function Control
gtpin::GtMemoryAccessChannelType | Type of access to memory with XYZW channels
gtpin::GtMemoryAddrModel | Class that represents Address Model of the memory surface access
gtpin::GtMemoryBuffer | Memory buffer in the virtual address space of the device
gtpin::GtMessageType | SEND message type
gtpin::GtMmapMethod | Method of the host-to-device memory mapping and sharing
gtpin::GtOclExecDesc | Execution descriptor of the OCL kernel (GPU_PLATFORM_OCL)
gtpin::GtOpcode | An attribute that specifies whether and how the instruction modifies flag register
gtpin::GtPredCtrl | An attribute that specifies whether and how the instruction is predicated
gtpin::GtPredicate | Arguments of the GEN Predicate Mask calculator
gtpin::GtProfileArray | Class that represents an array of data records in the profile buffer
gtpin::GtProfileTrace | Class that represents a trace - sequence of data records chronologically collected and stored in the profile buffer
gtpin::GtReg | Register descriptor
gtpin::GtRegFileType | < Ordinal number of the virtual register
gtpin::GtRegRegion | Register operand of the GEN instruction. Defines the register region accessed by the instruction
gtpin::GtRtKernelType | Type of a kernel (shader)
gtpin::GtSfid | Shared Function ID
gtpin::GtSimdWidth | SIMD width
gtpin::GtSrcModifier | Modifier of the source operand
gtpin::GtStateRegAccessor | Structure that defines some fields of the GEN State Register (SR) and provides access to these fields
gtpin::GtStatus | Status of the GTPin operation
gtpin::GtStride | Structure that specifies striding scheme of the register region
gtpin::GtSystolicInfo | Properties/attributes of the systolic array instruction
gtpin::GtThreadCtrl | Instruction attribute that controls thread switching
gtpin::GtVregType | Type of the virtual register
gtpin::GtVulkanExecDesc | Execution descriptor of the Vulkan shader (GPU_PLATFORM_VULKAN)
gtpin::IargBufferOffset< ARGT > | HLI argument value of type ARGT that represents offset in the GTPin profile buffer
gtpin::IargConstGrfRange | HLI argument that represents an immutable array of GRF registers
gtpin::IargDevicePtr | HLI argument that points to an object in the device memory
gtpin::IargFfTid | HLI argument that carries current Fixed Function Thread ID value
gtpin::IargGrfRange | HLI argument that represents a mutable array of GRF registers
gtpin::IargHostPtr | HLI argument that points to an object in the host memory
gtpin::IargInsOpMask | HLI argument that represents mask of scalar operations performed by the instruction on the vector of data elements
gtpin::IargPrime< ARGT > | Primary HLI argument value of type ARGT
gtpin::IargSimdMask | HLI argument that represents mask of effective SIMD channels at the instrumentation point
gtpin::IargSlmPtr | HLI argument that points to SLM memory
gtpin::IargTid | HLI argument that carries current Thread ID value
gtpin::IGtBbl | < Sequence of pointers to edges between basic blocks
gtpin::IGtCfg | Class that represents a control flow graph (CFG) and provides the code traversal interface
gtpin::IGtCore | < Handle to the tool registered with the GTPin core
gtpin::IGtEdge | Class that represents an edge between basic blocks of the Control Flow Graph
gtpin::IGtEvent | Abstract representation of the event generated by GTPin
gtpin::IGtEventHandler | Interface of the GTPin event handler
gtpin::IGtFunction | Class that represents a function in the Control Flow Graph
gtpin::IGtGenArch | Abstract singleton that provides access to generic and model-specific properties of the GEN architecture
gtpin::IGtGenCoder | The interface that facilitates the process of generating code for instrumentation procedures
gtpin::IGtGenModel | Basic properties of the GEN model
gtpin::IGtGenProcedure | Abstract representation of the GTPin code procedure
gtpin::IGtHliLibrary | Collection of the High-Level Instrumentation (HLI) modules
gtpin::IGtHliModule | Abstract representation of the High-Level Instrumentation (HLI) module
gtpin::IGtIarg | Abstract representation of the HLI function argument
gtpin::IGtIargFactory | Factory and container of HLI function arguments and return value representations
gtpin::IGtIns | < Identifier of the IGtIns instance
gtpin::IGtInsFactory | Class that defines virtual constructors of IGtIns objects representing various GEN instructions
gtpin::IGtInsHandler | Abstract interface of a class that handles instructions (of a procedure)
gtpin::IGtInternalEvent | Abstract representation of the event that reports internal GTPin error, warning, etc
gtpin::IGtIret | Abstract representation of the HLI function's return value
gtpin::IGtKernel | Basic properties of the GEN kernel as a compilation/instrumentation unit
gtpin::IGtKernelDispatch | Interface that controls kernel execution, from submission to completion
gtpin::IGtKernelEvent | Abstract representation of the event associated with a concrete kernel
gtpin::IGtKernelInstrument | Instrumentor of the GEN kernel
gtpin::IGtKnobArg | Abstract class that represents GTPin configuration argument (KNOB)
gtpin::IGtKnobRegistry | Abstract singleton that provides interface to the container of GTPin configuration arguments (KNOBs)
gtpin::IGtMemoryMapper | Class that provides the host-to-device memory mapping service. This feature enables transparent data sharing between host and device address spaces
gtpin::IGtProfileBuffer | Abstract representation of the profile data storage
gtpin::IGtProfileBufferAllocator | Abstract class that provides interface for allocation (reservation) memory blocks in the profile buffer
gtpin::IGtRegAllocator | Register allocation interface
gtpin::IGtTool | Abstract class that defines interface of the GTPin tool; i.e. set of callbacks invoked by the GTPin core
gtpin::IGtVreg | Virtual register
gtpin::IGtVregFactory | Factory and container of virtual registers
gtpin::IMemAllocator | < uint64_t scattered bit field
gtpin::IntRange< T, S > | Iterable range of integral values
gtpin::IntSized< size_t > | Signed integer type of a fixed size
gtpin::IsAkinPtr_< T, U > | Structure that checks if T and U refer/point to the same type, after recursively removing qualifiers and pointers
gtpin::IsArray< T > |
gtpin::IsPointer< T > |
gtpin::IsSameType< T, U > |
gtpin::IntRange< T, S >::Iterator | Random iterator in the range
gtpin::Knob< T > | Template class that provides interface to Knob argument of a type 'T'
gtpin::KnobDescriptor | Knob descriptor: set of immutable Knob properties
gtpin::KnobValue | Structure that holds knob value along with its type
gtpin::KnobVector< T > | Template class that provides constructor for Knob arguments associated with a vector of values of type 'T'
gtpin::RemoveCv_< T > |
gtpin::RemoveRef_< T > |
gtpin::Span< T > | Structure that points to an array of elements of type 'T', without owning it
gtpin::UintSized< size_t > | Unsigned integer type of a fixed size
gtpin::UniquePtr< T, D > | A smart pointer that provides some of the std::unique_ptr functionality for clients that cannot use C++11 STL
gtpin::Validatable< T, INV, UniqueType > | Wrapper of type 'T' with a distinct value 'INV' which is considered as invalid
gtpin::VariadicElement< IDX, ARGS > | < Range of uintptr_t values

All Data Structures Functions Variables Typedefs Enumerations Enumerator

      Copyright (C) 2013-2025 Intel Corporation

      SPDX-License-Identifier: MIT